import 'dart:io';

import 'package:camera/camera.dart';
import 'package:flutter/material.dart';
import 'package:flutter_ocr_camera/ocr_camera_widget.dart';

void main() {
  WidgetsFlutterBinding.ensureInitialized();
  runApp(MyApp());
}

class MyApp extends StatelessWidget {
  @override
  Widget build(BuildContext context) {
    return MaterialApp(
      title: 'Flutter Demo',
      theme: ThemeData(
        primarySwatch: Colors.blue,
      ),
      home: MyHomePage(title: 'Flutter Demo Flutter OCR camera package'),
    );
  }
}

class MyHomePage extends StatefulWidget {
  MyHomePage({Key? key, required this.title}) : super(key: key);

  final String title;

  @override
  _MyHomePageState createState() => _MyHomePageState();
}

class _MyHomePageState extends State<MyHomePage> {
  late List<CameraDescription> _cameras;
  String _imgPath = '';

  @override
  Widget build(BuildContext context) {
    Size _size = MediaQuery.of(context).size;
    return Scaffold(
      appBar: AppBar(
        title: Text(widget.title),
      ),
      body: Container(
        constraints: BoxConstraints.expand(),
        child: Visibility(
          visible: _imgPath.isNotEmpty,
          child: Image.file(
            File(_imgPath),
            width: _size.width,
            height: _size.height,
            fit: BoxFit.cover,
          ),
          replacement: Text('Image empty!'),
        ),
      ),
      floatingActionButton: Column(
        mainAxisAlignment: MainAxisAlignment.end,
        children: [
          Row(
            mainAxisAlignment: MainAxisAlignment.center,
            children: [
              TextButton(
                onPressed: () async {
                  _cameras = await availableCameras();
                  Navigator.push(
                      context,
                      MaterialPageRoute(
                          builder: (context) => OCRCameraWidget(
                                camera: _cameras,
                                maskType: MaskType.selfie,
                                onResult: (XFile? value) {
                                  setState(() {
                                    _imgPath = value!.path;
                                  });
                                  print(
                                    'XFile ----> ${value!.path}',
                                  );
                                },
                              )));
                },
                child: Text('Take a selfie'),
              ),
              TextButton(
                onPressed: () async {
                  _cameras = await availableCameras();
                  Navigator.push(
                      context,
                      MaterialPageRoute(
                          builder: (context) => OCRCameraWidget(
                                camera: _cameras,
                                onResult: (XFile? value) {
                                  setState(() {
                                    _imgPath = value!.path;
                                  });
                                  print(
                                    'XFile ----> ${value!.path}',
                                  );
                                },
                              )));
                },
                child: Text('Take a photo'),
              ),
            ],
          )
        ],
      ),
    );
  }
}
